DECLARE SUB Pal (colour%, R%, G%, B%)
'BXNes, the QBasic Nintendo Entertainment System Emulator
'--------------------------------------------------------
'$DYNAMIC
'$INCLUDE: 'bxnes.def'














HBlank = 113.85              'Number of cycles a Horizontal Blank lasts
SCREEN 13
InitiatePalette
FILE$ = COMMAND$
FILE$ = "roms\megamanj.nes"

OPEN FILE$ FOR BINARY AS #1
PowerON

'OPEN "debug.log" FOR OUTPUT AS #14
DO UNTIL INKEY$ = CHR$(27)
	CPU
	IF Cycles >= HBlank THEN
	Cycles = Cycles - HBlank
	ScanLine = ScanLine + 1
	IF ScanLine = 224 THEN    ' VBlank = On
		CLS
		PPU
		WriteMemory 8194, (ReadMemory(8194) OR 128)       'Setting bit 7 of $2002, VBlank Occurance
		IF ReadMemory(8192) AND 128 THEN                  'If the "Execute NMI on VBLank"-bit is set, then...
			Cycles = Cycles + 7                       'Cycles it costs to move in and out of an interrupt (latency-time)
			Highbyte% = (Register.PC AND 65280) \ 256 '65280 = 1111111100000000. Next divide by 256 to get the value as a byte
			LowByte% = Register.PC AND 255            '255 = 0000000011111111. So we get the low byte of the address
			StackWrite Highbyte%
			StackWrite LowByte%
			StackWrite (Register.Status AND 247)      'Push the register on the stack with the B/4th bit cleared
			Register.PC = NMI                         'And we go to the address specified by the NMI-vector
		END IF
	END IF
	IF ScanLine = 262 THEN    ' VBlank = Off
		ScanLine = 0
		Cycles = Cycles + 7                               'Since we return from an interrupt
		WriteMemory 8194, (ReadMemory(8194) AND 63)       'Setting bit 7 and 6 of $2002, VBlank Occurance / Sprite #0 Occurance
	END IF
	END IF

LOOP

CLOSE #1

REM $STATIC
FUNCTION Absolute!
'Addressingmode Absolute

		Register.PC = Register.PC + 1                                  'Increase programcounter
		A = ReadMemory%(Register.PC)                                   'Get low byte
		Register.PC = Register.PC + 1                                  'Increase programcounter
		B = ReadMemory%(Register.PC)                                   'Get high byte
		TempAbsolute! = A + 256 * B                                    'Add Highbyte to Lowbyte to get the address
		IF (TempAbsolute! AND 65536) THEN TempAbsolute! = TempAbsolute! AND 65535  'Make sure that is doesn't crosses the NES' borders
		Absolute! = TempAbsolute!
	 
END FUNCTION

FUNCTION AbsoluteX!
'Addressingmode Absolute Indexed with Index X

		Register.PC = Register.PC + 1                               'Increase programcounter
		A = ReadMemory%(Register.PC)                                'Get low byte
		Register.PC = Register.PC + 1                               'Increase programcounter
		B = ReadMemory%(Register.PC)                                'Get high byte
		TempX! = A + B * 256 + Register.X                           'Add the contents of the X index
		IF (TempX! AND 65536) THEN TempX! = TempX! AND 65535        'Make sure that is doesn't crosses the NES' borders
		AbsoluteX! = TempX!

END FUNCTION

FUNCTION AbsoluteY!
'Addressingmode Absolute Indexed with Index Y

		Register.PC = Register.PC + 1                                    'Increase programcounter
		A = ReadMemory%(Register.PC)                                     'Get lowbyte
		Register.PC = Register.PC + 1                                    'Increase programcounter
		B = ReadMemory%(Register.PC)                                     'Get highbyte
		C = B * 256
		TempY! = A + C + Register.Y                                      'Perform calculation
		IF (TempY! AND 65536) THEN TempY! = TempY! AND 65535             'Make sure that is doesn't crosses the NES' borders
		AbsoluteY! = TempY!


END FUNCTION

SUB CPU
'The 6502 CPU emulated...

OpCode = ReadMemory%(Register.PC)
'PRINT #14, HEX$(Register.PC + 1), HEX$(OpCode), HEX$(Register.X), HEX$(Register.Y), HEX$(Register.Accumulator)
SELECT CASE OpCode
	CASE &H1: Cycles = Cycles + 6: Op.ORA (Pre!)
	CASE &H5: Cycles = Cycles + 3: Op.ORA (ZeroPage!)
	CASE &H6: Cycles = Cycles + 5: Op.ASLM (ZeroPage!)
	CASE &H8: Cycles = Cycles + 3: Op.PHP
	CASE &H9: Cycles = Cycles + 2: Op.ORA (Direct!)
	CASE &HA: Cycles = Cycles + 2: Op.ASLA
	CASE &HD: Cycles = Cycles + 4: Op.ORA (Absolute!)
	CASE &HE: Cycles = Cycles + 6: Op.ASLM (Absolute!)
	CASE &H10: Cycles = Cycles + 2: Op.BPL (Relative%)
	CASE &H11: Cycles = Cycles + 5: Op.ORA (Post!)
	CASE &H15: Cycles = Cycles + 4: Op.ORA (ZeroPageX!)
	CASE &H16: Cycles = Cycles + 6: Op.ASLM (ZeroPageX!)
	CASE &H18: Cycles = Cycles + 2: Op.CLC
	CASE &H19: Cycles = Cycles + 4: Op.ORA (AbsoluteY!)
	CASE &H1D: Cycles = Cycles + 4: Op.ORA (AbsoluteX!)
	CASE &H1E: Cycles = Cycles + 7: Op.ASLM (AbsoluteX!)
	CASE &H20: Cycles = Cycles + 6: Op.JSR (Absolute!)
	CASE &H21: Cycles = Cycles + 6: Op.AND (Pre!)
	CASE &H24: Cycles = Cycles + 3: Op.BIT (ZeroPage!)
	CASE &H25: Cycles = Cycles + 3: Op.AND (ZeroPage!)
	CASE &H26: Cycles = Cycles + 5: Op.ROLM (ZeroPage!)
	CASE &H28: Cycles = Cycles + 4: Op.PLP
	CASE &H29: Cycles = Cycles + 2: Op.AND (Direct!)
	CASE &H2A: Cycles = Cycles + 2: Op.ROLA
	CASE &H2C: Cycles = Cycles + 4: Op.BIT (Absolute!)
	CASE &H2D: Cycles = Cycles + 4: Op.AND (Absolute!)
	CASE &H2E: Cycles = Cycles + 6: Op.ROLM (Absolute!)
	CASE &H30: Cycles = Cycles + 2: Op.BMI (Relative%)
	CASE &H31: Cycles = Cycles + 5: Op.AND (Post!)
	CASE &H35: Cycles = Cycles + 4: Op.AND (ZeroPageX!)
	CASE &H36: Cycles = Cycles + 6: Op.ROLM (ZeroPageX!)
	CASE &H38: Cycles = Cycles + 2: Op.SEC
	CASE &H39: Cycles = Cycles + 4: Op.AND (AbsoluteY!)
	CASE &H3D: Cycles = Cycles + 4: Op.AND (AbsoluteX!)
	CASE &H3E: Cycles = Cycles + 7: Op.ROLM (AbsoluteX!)
	CASE &H40: Cycles = Cycles + 4: Op.EOR (Absolute!)
	CASE &H41: Cycles = Cycles + 6: Op.EOR (Pre!)
	CASE &H45: Cycles = Cycles + 3: Op.EOR (ZeroPage!)
	CASE &H46: Cycles = Cycles + 5: Op.LSRM (ZeroPage!)
	CASE &H48: Cycles = Cycles + 3: Op.PHA
	CASE &H49: Cycles = Cycles + 2: Op.EOR (Direct!)
	CASE &H4A: Cycles = Cycles + 2: Op.LSRA
	CASE &H4C: Cycles = Cycles + 3: Op.JMP (Absolute!)
	CASE &H4D: Cycles = Cycles + 6: Op.RTI
	CASE &H4E: Cycles = Cycles + 6: Op.LSRM (Absolute!)
	CASE &H50: Cycles = Cycles + 2: Op.BVC (Relative%)
	CASE &H51: Cycles = Cycles + 5: Op.EOR (Post!)
	CASE &H55: Cycles = Cycles + 4: Op.EOR (ZeroPageX!)
	CASE &H56: Cycles = Cycles + 6: Op.LSRM (ZeroPageX!)
	CASE &H58: Cycles = Cycles + 2: Op.CLI
	CASE &H59: Cycles = Cycles + 4: Op.EOR (AbsoluteY!)
	CASE &H5D: Cycles = Cycles + 4: Op.EOR (AbsoluteX!)
	CASE &H5E: Cycles = Cycles + 7: Op.LSRM (AbsoluteX!)
	CASE &H60: Cycles = Cycles + 6: Op.RTS
	CASE &H61: Cycles = Cycles + 6: Op.ADC (Pre!)
	CASE &H65: Cycles = Cycles + 3: Op.ADC (ZeroPage!)
	CASE &H66: Cycles = Cycles + 5: Op.RORM (ZeroPage!)
	CASE &H68: Cycles = Cycles + 4: Op.PLA
	CASE &H69: Cycles = Cycles + 2: Op.ADC (Direct!)
	CASE &H6A: Cycles = Cycles + 2: Op.RORA
	CASE &H6C: Cycles = Cycles + 5: Op.JMP (Indirect!)
	CASE &H6D: Cycles = Cycles + 4: Op.ADC (Absolute!)
	CASE &H6E: Cycles = Cycles + 6: Op.RORM (Absolute!)
	CASE &H70: Cycles = Cycles + 2: Op.BVS (Relative%)
	CASE &H71: Cycles = Cycles + 5: Op.ADC (Post!)
	CASE &H75: Cycles = Cycles + 4: Op.ADC (ZeroPageX!)
	CASE &H76: Cycles = Cycles + 6: Op.RORM (ZeroPageX!)
	CASE &H78: Cycles = Cycles + 2: Op.SEI
	CASE &H79: Cycles = Cycles + 4: Op.ADC (AbsoluteY!)
	CASE &H7D: Cycles = Cycles + 4: Op.ADC (AbsoluteX!)
	CASE &H7E: Cycles = Cycles + 7: Op.RORM (AbsoluteX!)
	CASE &H81: Cycles = Cycles + 6: Op.STA (Pre!)
	CASE &H84: Cycles = Cycles + 3: Op.STY (ZeroPage!)
	CASE &H85: Cycles = Cycles + 3: Op.STA (ZeroPage!)
	CASE &H86: Cycles = Cycles + 3: Op.STX (ZeroPage!)
	CASE &H88: Cycles = Cycles + 2: Op.DEY
	CASE &H8A: Cycles = Cycles + 2: Op.TXA
	CASE &H8C: Cycles = Cycles + 4: Op.STY (Absolute!)
	CASE &H8D: Cycles = Cycles + 4: Op.STA (Absolute!)
	CASE &H8E: Cycles = Cycles + 4: Op.STX (Absolute!)
	CASE &H90: Cycles = Cycles + 2: Op.BCC (Relative%)
	CASE &H91: Cycles = Cycles + 6: Op.STA (Post!)
	CASE &H94: Cycles = Cycles + 4: Op.STY (ZeroPageX!)
	CASE &H95: Cycles = Cycles + 4: Op.STA (ZeroPageX!)
	CASE &H96: Cycles = Cycles + 4: Op.STX (ZeroPageY!)
	CASE &H98: Cycles = Cycles + 2: Op.TYA
	CASE &H99: Cycles = Cycles + 5: Op.STA (AbsoluteY!)
	CASE &H9A: Cycles = Cycles + 2: Op.TXS
	CASE &H9D: Cycles = Cycles + 5: Op.STA (AbsoluteX!)
	CASE &HA0: Cycles = Cycles + 2: Op.LDY (Direct!)
	CASE &HA1: Cycles = Cycles + 6: Op.LDA (Pre!)
	CASE &HA2: Cycles = Cycles + 2: Op.LDX (Direct!)
	CASE &HA4: Cycles = Cycles + 3: Op.LDY (ZeroPage!)
	CASE &HA5: Cycles = Cycles + 3: Op.LDA (ZeroPage!)
	CASE &HA6: Cycles = Cycles + 3: Op.LDX (ZeroPage!)
	CASE &HA8: Cycles = Cycles + 2: Op.TAY
	CASE &HA9: Cycles = Cycles + 2: Op.LDA (Direct!)
	CASE &HAA: Cycles = Cycles + 2: Op.TAX
	CASE &HAC: Cycles = Cycles + 4: Op.LDY (Absolute!)
	CASE &HAD: Cycles = Cycles + 4: Op.LDA (Absolute!)
	CASE &HAE: Cycles = Cycles + 4: Op.LDX (Absolute!)
	CASE &HB0: Cycles = Cycles + 2: Op.BCS (Relative%)
	CASE &HB1: Cycles = Cycles + 5: Op.LDA (Post!)
	CASE &HB4: Cycles = Cycles + 4: Op.LDY (ZeroPageX!)
	CASE &HB5: Cycles = Cycles + 4: Op.LDA (ZeroPageX!)
	CASE &HB6: Cycles = Cycles + 4: Op.LDX (ZeroPageX!)
	CASE &HB8: Cycles = Cycles + 2: Op.CLV
	CASE &HB9: Cycles = Cycles + 4: Op.LDA (AbsoluteY!)
	CASE &HBA: Cycles = Cycles + 2: Op.TSX
	CASE &HBC: Cycles = Cycles + 4: Op.LDY (AbsoluteX!)
	CASE &HBD: Cycles = Cycles + 4: Op.LDA (AbsoluteX!)
	CASE &HBE: Cycles = Cycles + 4: Op.LDX (AbsoluteY!)
	CASE &HC0: Cycles = Cycles + 2: Op.CPY (Direct!)
	CASE &HC1: Cycles = Cycles + 6: Op.CMP (Pre!)
	CASE &HC4: Cycles = Cycles + 3: Op.CPY (ZeroPage!)
	CASE &HC5: Cycles = Cycles + 3: Op.CMP (ZeroPage!)
	CASE &HC6: Cycles = Cycles + 5: Op.DEC (ZeroPage!)
	CASE &HC8: Cycles = Cycles + 2: Op.INY
	CASE &HC9: Cycles = Cycles + 2: Op.CMP (Direct!)
	CASE &HCA: Cycles = Cycles + 2: Op.DEX
	CASE &HCC: Cycles = Cycles + 4: Op.CPY (Absolute!)
	CASE &HCD: Cycles = Cycles + 4: Op.CMP (Absolute!)
	CASE &HCE: Cycles = Cycles + 6: Op.DEC (Absolute!)
	CASE &HD0: Cycles = Cycles + 2: Op.BNE (Relative%)
	CASE &HD1: Cycles = Cycles + 5: Op.CMP (Post!)
	CASE &HD5: Cycles = Cycles + 4: Op.CMP (ZeroPageX!)
	CASE &HD6: Cycles = Cycles + 6: Op.DEC (ZeroPageX!)
	CASE &HD8: Cycles = Cycles + 2: Op.CLD
	CASE &HD9: Cycles = Cycles + 4: Op.CMP (AbsoluteY!)
	CASE &HDD: Cycles = Cycles + 4: Op.CMP (AbsoluteX!)
	CASE &HDE: Cycles = Cycles + 7: Op.DEC (AbsoluteX!)
	CASE &HE0: Cycles = Cycles + 2: Op.CPX (Direct!)
	CASE &HE1: Cycles = Cycles + 6: Op.SBC (Pre!)
	CASE &HE4: Cycles = Cycles + 3: Op.CPX (ZeroPage!)
	CASE &HE5: Cycles = Cycles + 3: Op.SBC (ZeroPage!)
	CASE &HE6: Cycles = Cycles + 5: Op.INC (ZeroPage!)
	CASE &HE8: Cycles = Cycles + 2: Op.INX
	CASE &HE9: Cycles = Cycles + 2: Op.SBC (Direct!)
	CASE &HEA: Cycles = Cycles + 2: Op.NOP
	CASE &HEC: Cycles = Cycles + 4: Op.CPX (Absolute!)
	CASE &HED: Cycles = Cycles + 4: Op.SBC (Absolute!)
	CASE &HEE: Cycles = Cycles + 6: Op.INC (Absolute!)
	CASE &HF0: Cycles = Cycles + 2: Op.BEQ (Relative%)
	CASE &HF1: Cycles = Cycles + 5: Op.SBC (Post!)
	CASE &HF5: Cycles = Cycles + 4: Op.SBC (ZeroPageX!)
	CASE &HF6: Cycles = Cycles + 6: Op.INC (ZeroPageX!)
	CASE &HF8: Cycles = Cycles + 2: Op.SED
	CASE &HF9: Cycles = Cycles + 4: Op.SBC (AbsoluteY!)
	CASE &HFD: Cycles = Cycles + 4: Op.SBC (AbsoluteX!)
	CASE &HFE: Cycles = Cycles + 7: Op.INC (AbsoluteX!)
	'CASE &H0: Cycles = Cycles + 7: Op.BRK
	CASE ELSE
END SELECT

Register.PC = Register.PC + 1

END SUB

FUNCTION Direct!
'Addressingmode Direct

	Register.PC = Register.PC + 1      'Increase programcounter
	Direct! = Register.PC              'Pass the program counter as memory address (this is done in the direct mode, but it had to be emulated)
	
END FUNCTION

SUB DrawPatterntables
'Test for drawing patterntables

PPUMemaddress% = 0

FOR Patterntable% = 0 TO 1   'There are two patterntables
FOR VertRow% = 0 TO 15       'Each patterntables contains 16x16 tiles of 8x8 pixels
FOR HorzRow% = 0 TO 15       'HorzRow and VertRow indicate which tile we're currently drawing on the screen
FOR maal% = 0 TO 7           'Each tile consist of 8 bytes
	FOR Bit% = 0 TO 7          'Containg 8 bits, which...
		PixelColor% = 0
		IF (PPUMemory(PPUMemaddress%) AND 2 ^ Bit%) THEN PixelColor% = PixelColor% + 1            '... contain a 1 or a 0. This partially tells us which color to use as palette
		IF (PPUMemory(PPUMemaddress% + 8) AND 2 ^ Bit%) THEN PixelColor% = PixelColor% + 2        '... contain a 1 or a 0. This partially tells us which color to use as palette
		PSET (128 * Patterntable% + 8 * HorzRow% + 7 - Bit%, 8 * VertRow% + maal%), PixelColor%  'and then draw the pixel on the screen
	NEXT Bit%
	PPUMemaddress% = PPUMemaddress% + 1        'Add one, since we require the next byte from the PPU.
NEXT maal%
PPUMemaddress% = PPUMemaddress% + 8          'Increase by 8. Since every tile requires 2x 8 bytes, and we have only added 8 bytes sofar.
NEXT HorzRow%
NEXT VertRow%
NEXT Patterntable%

END SUB

FUNCTION Indirect!
'Addressingmode indirect

		Register.PC = Register.PC + 1                                  'Increase programcounter
		A = ReadMemory%(Register.PC)                                   'Get low byte
		Register.PC = Register.PC + 1                                  'Increase programcounter
		B = ReadMemory%(Register.PC)                                   'Get high byte
		Temp! = A + B * 256                                            'Add together
		IF (Temp! AND 65536) THEN Temp! = Temp! AND 65535              'Make sure that is doesn't crosses the NES' borders
		Indirect! = Temp!

END FUNCTION

SUB InitiatePalette
OPEN "bxnes.pal" FOR INPUT AS #20
FOR maal% = 0 TO 63
	INPUT #20, R%
	'PRINT R%
	INPUT #20, G%
	'PRINT G%
	INPUT #20, B%
	'PRINT B%
	Pal maal%, R%, G%, B%
	'SLEEP
NEXT maal%
END SUB

SUB InitModeQ
OUT &H3D4, &H11
v% = INP(&H3D5) AND &H7F
OUT &H3D4, &H11
OUT &H3D5, v%

OUT &H3C2, 227
OUT 980, 0
OUT 981, 95
OUT 980, 1
OUT 981, 63
OUT 980, 2
OUT 981, 64
OUT 980, 3
OUT 981, 130
OUT 980, 4
OUT 981, 74
OUT 980, 5
OUT 981, 154
OUT 980, 6
OUT 981, 35
OUT 980, 7
OUT 981, 178
OUT 980, 8
OUT 981, 0
OUT 980, 9
OUT 981, 97
OUT 980, 16
OUT 981, 10
OUT 980, 17
OUT 981, 172
OUT 980, 18
OUT 981, 255
OUT 980, 19
OUT 981, 32
OUT 980, 20
OUT 981, 64
OUT 980, 21
OUT 981, 7
OUT 980, 22
OUT 981, 26
OUT 980, 23
OUT 981, 163
OUT 964, 1
OUT 965, 1
OUT 964, 4
OUT 965, 14
OUT 974, 5
OUT 975, 64
OUT 974, 6
OUT 975, 5
vz% = INP(&H3DA)
OUT &H3C0, 16 OR &H20
OUT &H3C0, 65
vz% = INP(&H3DA)
OUT &H3C0, 19 OR &H20
OUT &H3C0, 0
END SUB

SUB Op.ADC (Memaddress!)
'Add memory to accumulator with carry

	TempADC% = ReadMemory%(Memaddress!)       'Get the value of the memory position
	TempCBit% = (Register.Status AND 1)       'Get the value of the Carry-bit
	TempACC% = Register.Accumulator           'Get the value of the Accumulator
	IF TempADC% > 127 THEN TempADC% = TempADC% - 256 'They are treated as signed values
	IF TempACC% > 127 THEN TempACC% = TempACC% - 256 'They are treated as signed values
	TempADD% = TempACC% + TempADC% + TempCBit%       'Perform the calculation
	IF TempADD% > 127 OR TempADD% < -128 THEN Register.Status = Register.Status OR 64 ELSE Register.Status = Rergister.Status AND 191 'Check if there isn't a overflow (this is still the signed value)
	IF Register.Accumulator + TempADC% + TempCBit% > 255 THEN Register.Status = Register.Status OR 1 ELSE Register.Status = Register.Status AND 254 'Check for carry
	IF TempADD% < 0 THEN TempADD% = TempADD% + 256 'Make is unsigned again (we don't have to check for values above 255. since 127+127+1 is never larger then 255
	Register.Accumulator = TempADD%
	SetNZ (Register.Accumulator)

END SUB

SUB Op.AND (Memaddress!)
'"AND" memory with accumulator

		Register.Accumulator = Register.Accumulator AND ReadMemory%(Memaddress!)
		SetNZ (Register.Accumulator)

END SUB

SUB Op.ASLA
'Shift Left One Bit (Accumulator)
 
	IF (Register.Accumulator AND 128) THEN                     'If the 7th bit = 1 THEN
		Register.Status = Register.Status OR 1                   'turn the Carry Bit into 1
		Register.Accumulator = Register.Accumulator AND 127      'and turn the 7th bit into 0
	ELSE                                                       'If the 7th bit = 1 THEN
		Register.Status = Register.Status AND 254                'turn the Carry Bit into 0
	END IF
	Register.Accumulator = Register.Accumulator * 2            'mutiply by 2 to get the left-shift

END SUB

SUB Op.ASLM (Memaddress!)
'Shift Left One Bit (Memory)

	TempASL% = ReadMemory%(Memaddress!)
	IF (TempASL% AND 128) THEN                     'If the 7th bit = 1 THEN
		Register.Status = Register.Status OR 1       'turn the Carry Bit into 1
		TempASL% = TempASL% AND 127                  'and turn the 7th bit into 0
	ELSE                                           'If the 7th bit = 1 THEN
		Register.Status = Register.Status AND 254    'turn the Carry Bit into 0
	END IF
	TempASL% = TempASL% * 2                        'mutiply by 2 to get the left-shift
	WriteMemory Memaddress!, TempASL%              'and write it to the memory

END SUB

SUB Op.BCC (SkipAmount%)
'Branch on Carry Clear

		IF (Register.Status AND 1) = 0 THEN Register.PC = Register.PC + SkipAmount%

END SUB

SUB Op.BCS (SkipAmount%)
'Branch on carry set
	 
		IF (Register.Status AND 1) THEN Register.PC = Register.PC + SkipAmount%

END SUB

SUB Op.BEQ (SkipAmount%)
'Branch on result zero

		IF (Register.Status AND 2) THEN Register.PC = Register.PC + SkipAmount%

END SUB

SUB Op.BIT (Memaddress!)
'Test bits in memory with accumulator

	TempBit% = ReadMemory%(Memaddress!)
	IF (128 AND TempBit%) THEN Register.Status = Register.Status OR 128 ELSE Register.Status = Register.Status AND 127  'If un-AND-ed value of the memory's 7th bit is set, then set N bit else, unset N bit
	IF (64 AND TempBit%) THEN Register.Status = Register.Status OR 64 ELSE Register.Status = Register.Status AND 191    'If un-AND-ed value of the memory's 6th bit is set, then set V bit else, unset V bit
	IF (TempBit% AND Register.Accumulator) = 0 THEN Register.Status = Register.Status OR 2 ELSE Register.Status = Register.Status AND 253

END SUB

SUB Op.BMI (SkipAmount%)
'Branch on result minus

		IF (Register.Status AND 128) THEN Register.PC = Register.PC + SkipAmount%

END SUB

SUB Op.BNE (SkipAmount%)
'Branch on result not zero

		IF (Register.Status AND 2) = 0 THEN Register.PC = Register.PC + SkipAmount%

END SUB

SUB Op.BPL (SkipAmount%)
'Branch on result plus
	 
		IF (Register.Status AND 128) = 0 THEN Register.PC = Register.PC + SkipAmount%
	 
END SUB

SUB Op.BRK
'Force break

END SUB

SUB Op.BVC (SkipAmount%)
'Branch on overflow clear
	 
		IF (Register.Status AND 64) = 0 THEN Register.PC = Register.PC + SkipAmount%

END SUB

SUB Op.BVS (SkipAmount%)
'Branch on overflow set

		IF (Register.Status AND 64) THEN Register.PC = Register.PC + SkipAmount%

END SUB

SUB Op.CLC
'Clear carry flag

		Register.Status = Register.Status AND 254

END SUB

SUB Op.CLD
'Clear decimal mode

		Register.Status = Register.Status AND 247

END SUB

SUB Op.CLI
'Clear interrupt disable bit

		Register.Status = Register.Status AND 251

END SUB

SUB Op.CLV
'Clear overflow flag

		Register.Status = Register.Status AND 191

END SUB

SUB Op.CMP (Memaddress!)
'Compare memory and accumulator

	SetCMP ReadMemory%(Memaddress!), Register.Accumulator

END SUB

SUB Op.CPX (Memaddress!)
'Compare Memory and Index X

	SetCMP ReadMemory%(Memaddress!), Register.X

END SUB

SUB Op.CPY (Memaddress!)
'Compare Memory and Index Y

	SetCMP ReadMemory%(Memaddress!), Register.Y

END SUB

SUB Op.DEC (Memaddress!)
'Decrement memory by one

		TempDEC% = ReadMemory%(Memaddress!)
		TempDEC% = TempDEC% - 1
		IF TempDEC% < 0 THEN TempDEC% = 256 + TempDEC%
		WriteMemory Memaddress!, TempDEC%
		SetNZ (TempDEC%)

END SUB

SUB Op.DEX
'Decrement Index X by one

		Register.X = Register.X - 1
		IF Register.X < 0 THEN Register.X = 256 + Register.X
		SetNZ (Register.X)

END SUB

SUB Op.DEY
'Decrement Index Y by one

		Register.Y = Register.Y - 1
		IF Register.Y < 0 THEN Register.Y = 256 + Register.Y
		SetNZ (Register.Y)

END SUB

SUB Op.EOR (Memaddress!)
'"Exclusive-Or" memory with accumulator

		TempEOR% = ReadMemory%(Memaddress!)
		Register.Accumulator = Register.Accumulator XOR TempEOR%
		SetNZ (Register.Accumulator)

END SUB

SUB Op.INC (Memaddress!)
'Increment memory by one

		TempINC% = ReadMemory%(Memaddress!)
		TempINC% = TempINC% + 1
		IF TempINC% > 255 THEN TempINC% = TempINC% - 256
		WriteMemory Memaddress!, TempINC%
		SetNZ (TempINC%)

END SUB

SUB Op.INX
'Increment Index X by one

		Register.X = Register.X + 1
		IF Register.X > 255 THEN Register.X = Register.X - 256
		SetNZ (Register.X)

END SUB

SUB Op.INY
'Increment Index Y by one

		Register.Y = Register.Y + 1
		IF Register.Y > 255 THEN Register.Y = Register.Y - 256
		SetNZ (Register.Y)

END SUB

SUB Op.JMP (Memaddress!)
'Jump to new location

	Register.PC = Memaddress! - 1           'Just do it... and substract one to maintain this address even after programcounter has been increased next time (little correction)
	
END SUB

SUB Op.JSR (Memaddress!)
'Jump to new location saving return address

	Register.PC = Register.PC - 1               'A little correction. Later on the PC will be increased by one, but it shouldn't be so using this jump. So we just add a little correction :)
	StackWrite ((Register.PC AND 65280) / 256)  'Write programcounter to stack (low byte, high byte). 65280 ->1111111100000000
	StackWrite (Register.PC AND 255)            'Write programcounter to stack (low byte, high byte). 255 ->0000000011111111
	Register.PC = Memaddress! - 1               'Just do it... however substract one to maintain this address
 
END SUB

SUB Op.LDA (Memaddress!)
'Load Accumulator with Memory

		Register.Accumulator = ReadMemory%(Memaddress!)
		SetNZ (Register.Accumulator)

END SUB

SUB Op.LDX (Memaddress!)
'Load Index X with Memory
	 
		Register.X = ReadMemory%(Memaddress!)
		SetNZ (Register.X)

END SUB

SUB Op.LDY (Memaddress!)
'Load Index Y with Memory

		Register.Y = ReadMemory%(Memaddress!)
		SetNZ (Register.Y)

END SUB

SUB Op.LSRA
'Shift right one bit (accumulator)

	IF (Register.Accumulator AND 1) THEN                  'If the 0th bit = 1 THEN
		Register.Status = Register.Status OR 1              'turn the Carry Bit into 1
		Register.Accumulator = Register.Accumulator AND 254 'and turn the 0th bit into 0
	ELSE                                                  'If the 0th bit = 0 THEN
		Register.Status = Register.Status AND 254           'turn the Carry Bit into 0
	END IF
	Register.Accumulator = Register.Accumulator \ 2       'divide by 2 to get the right-shift
 
END SUB

SUB Op.LSRM (Memaddress!)
'Shift right one bit (memory)
 
	TempLSR% = ReadMemory%(Memaddress!)
	IF (TempLSR% AND 1) THEN                       'If the 0th bit = 1 THEN
		Register.Status = Register.Status OR 1       'turn the Carry Bit into 1
		TempLSR% = TempLSR% AND 254                  'and turn the 0th bit into 0
	ELSE                                           'If the 0th bit = 0 THEN
		Register.Status = Register.Status AND 254    'turn the Carry Bit into 0
	END IF
	TempLSR% = TempLSR% \ 2                        'divide by 2 to get the right-shift
	WriteMemory Memaddress!, TempLSR%              'and write it to the memory

END SUB

SUB Op.NOP
'No Operation

END SUB

SUB Op.ORA (Memaddress!)
'"OR" memory with accumulator

		Register.Accumulator = Register.Accumulator OR ReadMemory%(Memaddress!)
		SetNZ (Register.Accumulator)

END SUB

SUB Op.PHA
'Push Accumulator on stack

	StackWrite Register.Accumulator         'Write the accumulator to the stack

END SUB

SUB Op.PHP
'Push processor status on stack

	StackWrite Register.Status         'Write the status to the stack

END SUB

SUB Op.PLA
'Pull accumulator fom stack

	Register.Accumulator = StackRead%      'Read accumulator from stack
	SetNZ (Register.Accumulator)           'Set the N and Z bit in the Status register

END SUB

SUB Op.PLP
'Pull processor status from stack
 
	Register.Status = StackRead%        'Read accumulator from stack
 
END SUB

SUB Op.ROLA
'Rotate one bit left (accumulator)

	TempROL% = Register.Accumulator
	IF (Register.Status AND 1) THEN TempROL% = TempROL% OR 1 'Incase the Carry Bit equals one, add one to the temporary ROL integer
	IF (TempROL% AND 128) THEN                               'If the 7th bit = 1 THEN
		Register.Status = Register.Status OR 1                 'turn the Carry Bit into 1
		TempROL% = TempROL% AND 127                            'and turn the 7th bit into 0
	ELSE                                                     'If the 7th bit = 1 THEN
		Register.Status = Register.Status AND 254              'turn the Carry Bit into 0
	END IF
	TempROL% = TempROL% * 2                                  'mutiply by 2 to get the left-shift
	Register.Accumulator = TempROL%

END SUB

SUB Op.ROLM (Memaddress!)
'Rotate one bit left (memory)

	TempROL% = ReadMemory%(Memaddress!)
	IF (Register.Status AND 1) THEN TempROL% = TempROL% OR 1 'Incase the Carry Bit equals one, add one to the temporary ROL integer
	IF (TempROL% AND 128) THEN                               'If the 7th bit = 1 THEN
		Register.Status = Register.Status OR 1                 'turn the Carry Bit into 1
		TempROL% = TempROL% AND 127                            'and turn the 7th bit into 0
	ELSE                                                     'If the 0th bit = 0 THEN
		Register.Status = Register.Status AND 254              'turn the Carry Bit into 0
	END IF
	TempROL% = TempROL% * 2                                  'mutiply by 2 to get the left-shift
	WriteMemory Memaddress!, TempROL%                        'and write it to the memory

END SUB

SUB Op.RORA
'Rotate one bit right (accumulator)

	TempROR% = Register.Accumulator
	IF (Register.Status AND 1) THEN TempROR% = TempROR% + 256
	IF (TempROR% AND 1) THEN                       'If the 0th bit = 1 THEN
		Register.Status = Register.Status OR 1       'turn the Carry Bit into 1
		TempROR% = TempROR% AND 254                  'and turn the 0th bit into 0
	ELSE                                           'If the 0th bit = 0 THEN
		Register.Status = Register.Status AND 254    'turn the Carry Bit into 0
	END IF
	TempROR% = TempROR% \ 2                        'divide by 2 to get the right-shift
	Register.Accumulator = TempLSR%

END SUB

SUB Op.RORM (Memaddress!)
'Rotate one bit right (memory)
 
	TempROR% = ReadMemory%(Memaddress!)
	IF (Register.Status AND 1) THEN TempROR% = TempROR% + 256
	IF (TempROR% AND 1) THEN                       'If the 0th bit = 1 THEN
		Register.Status = Register.Status OR 1       'turn the Carry Bit into 1
		TempROR% = TempROR% AND 254                  'and turn the 0th bit into 0
	ELSE                                           'If the 0th bit = 0 THEN
		Register.Status = Register.Status AND 254    'turn the Carry Bit into 0
	END IF
	TempROR% = TempROR% \ 2                        'divide by 2 to get the right-shift
	WriteMemory Memaddress!, TempLSR%              'and write it to the memory

END SUB

SUB Op.RTI
'Return from interrupt

	Register.Status = StackRead%                    'Get the processor status
	A = StackRead%
	B = StackRead%
	C = B * 256
	Register.PC = A + C                             'Get the address from the stack (high byte, low byte)

END SUB

SUB Op.RTS
'Return from subroutine

	A = StackRead%
	B = StackRead%
	C = B * 256
	Register.PC = A + C + 1     'Get the address from the stack (high byte, low byte)
 
END SUB

SUB Op.SBC (Memaddress!)
'Substract memory from accumulator with borrow

	TempSBC% = ReadMemory%(Memaddress!)        'Get the value of the memory position
	TempCBit% = (Register.Status AND 1) XOR 1 'Get the value of the Carry-bit
	TempACC% = Register.Accumulator           'Get the value of the Accumulator
	IF TempADC% > 127 THEN TempADC% = TempADC% - 256 'They are treated as signed values
	IF TempACC% > 127 THEN TempACC% = TempACC% - 256 'They are treated as signed values
	TempDEC% = TempACC% - TempADC% - TempCBit%       'Perform the calculation
	IF TempDEC% > 127 OR TempDEC% < -128 THEN Register.Status = Register.Status OR 64 ELSE Register.Status = Rergister.Status AND 191 'Check if there isn't a overflow (this is still the signed value)
	IF TempSBC% > 0 THEN IF TempACC% >= 0 THEN Register.Status = Register.Status OR 1 ELSE Register.Status = Register.Status AND 254 'Check for carry
	Register.Accumulator = Register.Accumulator - TempSBC% - TempCBit%
	IF Register.Accumulator >= 0 THEN Register.Status = Register.Status OR 1 ELSE Register.Accumulator = Register.Accumulator + 256: Register.Status = Register.Status AND 254
	SetNZ (Register.Accumulator)

END SUB

SUB Op.SEC
'Set carry flag

		Register.Status = Register.Status OR 1

END SUB

SUB Op.SED
'Set decimal mode

		Register.Status = Register.Status OR 8

END SUB

SUB Op.SEI
'Set interrupt disable status

		Register.Status = Register.Status OR 4

END SUB

SUB Op.STA (Memaddress!)
'Store accumulator in memory

	WriteMemory Memaddress!, Register.Accumulator 'Just perform the write from accumulator to memory

END SUB

SUB Op.STX (Memaddress!)
'Store Index X in Memory

	WriteMemory Memaddress!, Register.X 'Just perform the write from Index X to memory

END SUB

SUB Op.STY (Memaddress!)
'Store Index Y in Memory

	WriteMemory Memaddress!, Register.Y 'Just perform the write from Index Y to memory

END SUB

SUB Op.TAX
'Transfer Accumulator to Index X

		Register.X = Register.Accumulator
		SetNZ (Register.X)

END SUB

SUB Op.TAY
'Transfer Accumulator to Index Y

		Register.Y = Register.Accumulator
		SetNZ (Register.Y)

END SUB

SUB Op.TSX
'Transfer stack pointer to Index X

	Register.X = Register.SP           'Do the transfer
END SUB

SUB Op.TXA
'Transfer Index X to Accumulator

		Register.Accumulator = Register.X
		SetNZ (Register.Accumulator)

END SUB

SUB Op.TXS
'Transfer Index X to stack pointer

	Register.SP = Register.X         'Do the transfer

END SUB

SUB Op.TYA
'Transfer Index Y to Accumulator

		Register.Accumulator = Register.Y
		SetNZ (Register.Accumulator)

END SUB

SUB Pal (colour%, R%, G%, B%)
OUT &H3C8, colour%
OUT &H3C9, R%
OUT &H3C9, G%
OUT &H3C9, B%
END SUB

FUNCTION Post!
'Addressingmode Post Indexed Y

	Register.PC = Register.PC + 1
	Address1 = ReadMemory%(Register.PC)
	A = ReadMemory%(Address1)
	B = ReadMemory%(Address1 + 1)
	Post! = A + B * 256 + Register.Y

END FUNCTION

SUB PowerON
'Starting the NES with the Power-button

'Initializing basic variables
Register.SP = 255              'The stack pointer points to the top of the stack
Register.PC = 17               'The program counter is set at the beginning of the ROM (skipping the 16 byte header)
Register.X = 0
Register.Y = 0
Register.Status = 0


'Reading info from the NES header
PRINT "Reading info from NES header..."

GET #1, 1, Byte: Header$ = Byte
GET #1, 2, Byte: Header$ = Header$ + Byte
GET #1, 3, Byte: Header$ = Header$ + Byte
GET #1, 4, Byte: Header$ = Header$ + Byte
GET #1, 5, Byte: PrgCount% = ASC(Byte)
GET #1, 6, Byte: ChrCount% = ASC(Byte)
GET #1, 7, Byte: ControlByte1 = ASC(Byte)
GET #1, 8, Byte: ControlByte2 = ASC(Byte)
MapperNR% = ((ControlByte1 AND 240) / 8) + (ControlByte2 AND 240)

'Show information on the NES file
IF Header$ = "NES" + CHR$(26) THEN PRINT "Correct NES-format..." ELSE PRINT "Incorrect NES-format": END
PRINT "Number of 16Kb PRG-ROM pages:", PrgCount%
PRINT "Number of  8Kb CHR-ROM pages:", ChrCount%
PRINT "Scrolling                   :", SPACE$(1) + Scrolling$
PRINT




IF MapperNR% = 0 THEN
	 
		PRINT "Mapper 0 detected: No Mapper": PRINT "Loading game into memory..."
	 
		IF PrgCount% = 1 THEN                      'Incase there's only one 16KB ROM page, then load it into both $C000 and $8000
			FOR maal! = 0 TO 16383                   'Do it 16K times (1K=1024)
				GET #1, Register.PC, Byte              'Get the byte...
				WriteMemory (49152 + maal!), ASC(Byte) 'Write to the memory... (from $C000)
				WriteMemory (32768 + maal!), ASC(Byte) 'Write to the memory... (from $8000)
				Register.PC = Register.PC + 1          'And increase the program counter
			NEXT maal!
	 
		ELSE                                                   'else just load it into 8000 to FFFF
			FOR maal! = 0 TO (16383 * PrgCount% + (PrgCount% - 1)) 'Do it 16K times (1K=1024)
				GET #1, Register.PC, Byte                          'Get the byte...
				WriteMemory (32768 + maal!), ASC(Byte)             'Write to the memory...
				Register.PC = Register.PC + 1                      'And increase the program counter
			NEXT maal!
		END IF
	 
		FOR maal! = 0 TO 8191              'We don't have to check for the amount of Prg Pages, because it's Mapper 0, which has only 1 8KB PRG Page
				GET #1, Register.PC, Byte      'Get the byte from the ROM-file and write it to the memory
				PPUMemory(maal!) = ASC(Byte)   'We don't have a writting sub for the PPU memory, so just do it like this
				Register.PC = Register.PC + 1  'Increase Program counter
		NEXT maal!

END IF
'IF MapperNR% > 0 THEN PRINT "This game is not supported.": END

'Get the addresses of the interrupt jumps from the interruptvectors
A = ReadMemory%(65530): B = ReadMemory%(65531): NMI = A + B * 256
A = ReadMemory%(65532): B = ReadMemory%(65533): NESReset = A + B * 256
A = ReadMemory%(65534): B = ReadMemory%(65535): IRQBRK = A + B * 256

Register.PC = NESReset

END SUB

SUB PPU
'The NES PPU (Picture Processing Unit) emulated...



'--------------------------------------------------------------------------------
'BACKGROUND
'--------------------------------------------------------------------------------

PatTable% = ((ReadMemory%(8192) AND 16) \ 16) * 4096                                                             _
'$2000 AND "00010000". Gives 16, when bit 5 is a 1, else 0. Then divide by 16, so we get a 0 or 1. Then multiply by &H1000 or 4096 and we've got the correct base address of the correct patterntable.
NameTable% = 8192 + ((ReadMemory%(8192) AND 3) * 1024)'$2000 AND "00000011". Gives 0,1,2 or 3. When multiplied by &H400 and added to &H2000, we've got the base address of the Nametable.
AttrTable% = NameTable% + 960                         'We add 960 (&H3C0) to the base address of the name table to get the base address of the Attribute Table
TilesDone% = 0                                        'Counts the number of tiles for the background drawn sofar.
FOR TilePosY% = 0 TO 29                               '30 tiles vertically
	FOR TilePosX% = 0 TO 31                             '32 tiles horizontally
		Tilenr% = PPUMemory(NameTable% + TilesDone%)      'We get the Tilenr. This is used to get the correct tile from the pattern table
		PPUMemaddress% = PatTable% + 16 * (Tilenr%)       'we calculate the address in the PPU memory where the data for the specified tile is stored
			FOR TileY% = 0 TO 7                             'A tile has a resolution of 8 vertical pixels...
				FOR TileX% = 0 TO 7                           'And 8 horizontal pixels
					PixelColor% = 0                             'Now we start calculating the correct color to put on the screen and we do so
					IF (PPUMemory(PPUMemaddress%) AND 2 ^ TileX%) THEN PixelColor% = PixelColor% + 1
					IF (PPUMemory(PPUMemaddress% + 8) AND 2 ^ TileX%) THEN PixelColor% = PixelColor% + 2
					AttributeTableAddress% = (TilePosY% \ 4) * 8 + (TilePosX% \ 4)
					SquareNR% = ((TilePosY% MOD 4) \ 2) * 2 + ((TilePosX% MOD 4) \ 2)
					Attribute% = PPUMemory(AttributeTableAddress%)
					Attribute% = (Attribute% AND (2 ^ (SquareNR% * 2) + 2 ^ ((SquareNR% * 2) + 1)))
					Attribute% = Attribute% / (2 ^ (SquareNR% * 2))
					Attribute% = Attribute% * 4
					PixelColor% = PixelColor% + Attribute%
					PSET (TilePosX% * 8 + 7 - TileX%, TilePosY% * 8 + TileY%), PixelColor%
				NEXT TileX%
				PPUMemaddress% = PPUMemaddress% + 1           'Add one, since we require the next byte from the PPU.
			NEXT TileY%
		TilesDone% = TilesDone% + 1                       'Since we're done with this tile, we increase this number and head towards the next tile
	NEXT TilePosX%
NEXT TilePosY%
'END IF






'--------------------------------------------------------------------------------
'SPRITES
'--------------------------------------------------------------------------------
IF ReadMemory(8193) AND 16 THEN 'Display only when bit #4 has been set in the register at $2001 (Display Sprite Bit)
PatTable% = ((ReadMemory%(8192) AND 8) \ 8) * 4096    '$2000 AND "00001000". Gives 8, when bit 4 is a 1, else 0. Then divide by 8, so we get a 0 or 1. Then multiply by &H1000 or 4096 and we've got the correct base address of the correct patterntable
FOR Sprite% = 0 TO 63                                 'the NES supports up to 64 sprites numbered from 0 to 63
	Tilenr% = SprRam(Sprite% * 4 + 1)                   'we get the tilenumber, so we know which tile to use from the patterntables
	PPUMemaddress% = PatTable% + 16 * (Tilenr%)         'using this Tilenr%, we can get the correct address where to data to draw the sprite is stored
	FOR TileY% = 0 TO 7                                 'A tile has a resolution of 8 vertical pixels...
		FOR TileX% = 0 TO 7                               'And 8 horizontal pixels
			PixelColor% = 0                                 'Now we start calculating the correct color to put on the screen and we do so
			IF (PPUMemory(PPUMemaddress%) AND 2 ^ TileX%) THEN PixelColor% = PixelColor% + 1
			IF (PPUMemory(PPUMemaddress% + 8) AND 2 ^ TileX%) THEN PixelColor% = PixelColor% + 2
			PixelColor% = PixelColor% + (SprRam(Sprite% * 4 + 2) AND 3) * 4                             'bits 0 and 1 of the 2nd byte of the ram of a sprite gives the high bytes for the color to use.
			IF PixelColor% > 0 THEN                         'SUPPORT: transparant sprites
				SELECT CASE (SprRam(Sprite% * 4 + 2) AND 192) 'SUPPORT: sprite-flipping
					CASE 192                                    'Vertical Flip & Horizontal flip
						PSET (SprRam(Sprite% * 4 + 3) + TileX%, SprRam(Sprite% * 4) - 1 + 7 - TileY%), PixelColor%
					CASE 128                                    'Vertical Flip
						PSET (SprRam(Sprite% * 4 + 3) + TileX%, SprRam(Sprite% * 4) - 1 + TileY%), PixelColor%
					CASE 64                                     'Horizontal Flip
						PSET (SprRam(Sprite% * 4 + 3) + 7 - TileX%, SprRam(Sprite% * 4) - 1 + 7 - TileY%), PixelColor%
					CASE 0                                      'No flipping
						PSET (SprRam(Sprite% * 4 + 3) + 7 - TileX%, SprRam(Sprite% * 4) - 1 + TileY%), PixelColor%
				END SELECT
			END IF
		NEXT TileX%
		PPUMemaddress% = PPUMemaddress% + 1              'Add one, since we require the next byte from the PPU.
	NEXT TileY%
NEXT Sprite%
END IF

END SUB

FUNCTION Pre!
'Addressingmode Pre Indexed X

	Register.PC = Register.PC + 1                                  'Increase programcounter
	PreTemp% = ReadMemory%(Register.PC) + Register.X               'Make use of pretemp to calculte the new get-address
	IF PreTemp% > 255 THEN PreTemp% = PreTemp% AND 255             'Make sure it's still a zero-page address (255 max. = 8 bits)
	A = ReadMemory%(CSNG(PreTemp%))
	B = ReadMemory%(CSNG(PreTemp% + 1))
	C = B * 256
	Pre! = A + C                                                   'Now calculate the new address

END FUNCTION

FUNCTION QPoint% (X%, Y%)
DEF SEG = &HA000
 
	QPoint = PEEK((256& * Y%) + X%)
DEF SEG
END FUNCTION

SUB QPSET (X%, Y%, Colr%)
DEF SEG = &HA000
	POKE (256& * Y%) + X%, Colr%
DEF SEG
END SUB

FUNCTION ReadMemory% (ReadPlace!)

SELECT CASE ReadPlace!
	CASE 8194                                            'Special register: $2002
		ReadMemory% = CPUMemory2(ReadPlace! - 8192)
		CPUMemory2(2) = CPUMemory2(2) AND 127                 'Clear bit 7 of $2002 (VBlank Occurance-bit)
		CPUMemory2(5) = 0                                     'Clear $2005
		CPUMemory2(6) = 0                                     'Clear $2006
	CASE 8196                                            'Special register: $2004
		ReadMemory% = SprRam(SprRamAddress)                            'read from the Sprite RAM using the address specified by writing to $2003
	CASE 8199                                            'Special register: $2007
		ReadMemory% = PPUMemory(VramAddress)                                                                'read from the PPU using the address specified by writing to $2006
		IF (ReadMemory%(8192) AND 4) THEN VramAddress = VramAddress + 32 ELSE VramAddress = VramAddress + 1 'Increase correctly (dependant on $2000) after accessing this register
	CASE 0 TO 8191
		ReadMemory% = CPUMemory1(ReadPlace!)
	CASE 8192 TO 20479
		ReadMemory% = CPUMemory2(ReadPlace! - 8192)
	CASE 20480 TO 24575
		ReadMemory% = CPUMemory3(ReadPlace! - 20480)
	CASE 24576 TO 32767
		ReadMemory% = CPUMemory4(ReadPlace! - 24576)
	CASE 32768 TO 49151
		ReadMemory% = CPUMemory5(ReadPlace! - 32768)
	CASE 49152 TO 65536
		ReadMemory% = CPUMemory6(ReadPlace! - 49152)
END SELECT
END FUNCTION

FUNCTION Relative%
'Relative: Used in the Branch On-instructions

		Register.PC = Register.PC + 1          'Increase programcounter
		A% = ReadMemory%(Register.PC)          'Read value from memory
		IF A% > 127 THEN A% = A% - 256         'If value is larger then 127, then it is negative. Use 2's compliment to find out what value it is.
		Relative% = A%
		
END FUNCTION

SUB SetCMP (Value1%, Value2%)
'Sets the flags needed when performing an compare opcode

SELECT CASE (Value1% - Value2%)
	CASE IS = 0
		Register.Status = Register.Status AND 127     'Clear Sign Flag
		Register.Status = Register.Status OR 3        'Set Carry and Zero Flag
	CASE IS < 0
		Register.Status = Register.Status OR 1        'Set Carry Flag
		Register.Status = Register.Status AND 126     'Clear Sign Flag and Zero Flag
	CASE IS > 0
		Register.Status = Register.Status OR 128      'Set Sign Flag
		Register.Status = Register.Status AND 252     'Clear Carry and Zero Flag
END SELECT

END SUB

SUB SetNZ (Value%)
'Setting the N and the Z bit of the status register based on the value of "Value%"

	IF Value% = 0 THEN Register.Status = Register.Status OR 2 ELSE Register.Status = Register.Status AND 253
	IF Value% > 127 THEN Register.Status = Register.Status OR 128 ELSE Register.Status = Register.Status AND 127

END SUB

FUNCTION StackRead%
'Read from stack

	Register.SP = Register.SP - 1                          'Decrease stackpointer by one to indicate the new free location
	StackRead% = ReadMemory%(511 - Register.SP)            'Perform the read (stack = &H0100 TO &H01FF
 
END FUNCTION

SUB StackWrite (Value%)
'Write to stack

	WriteMemory (511 - Register.SP), Value%   'Perform the write (stack = &H0100 TO &H01FF
	Register.SP = Register.SP + 1             'Increase stackpointer by one to indicate the new free location

END SUB

SUB WriteMemory (WritePlace!, Value%)

SELECT CASE WritePlace!
	CASE 8195
		SprRamAddress = Value%                             'Special register: $2003
	CASE 8196                                            'Special register: $2004
		SprRam(SprRamAddress) = Value%                     'write to the Sprite RAM using the address specified by writing to $2003
	CASE 8198
		VramAddress = (VramAddress AND 255) * 256 + Value% 'Special register: $2006
	CASE 8199                                            'Special register: $2007
		IF VramAddress < &H4000 THEN
		PPUMemory(VramAddress) = Value%                    'write to the PPU using the address specified by writing to $2006
		END IF
		IF (ReadMemory%(8192) AND 4) THEN VramAddress = VramAddress + 32 ELSE VramAddress = VramAddress + 1 'Increase correctly (dependant on $2000) after accessing this register
		IF VramAddress > 32767 THEN VramAddress = VramAddress - 32768
	CASE 16404                                           'Special register: $4014
		FOR ByteNR% = 0 TO 255
			SprRam(ByteNR%) = ReadMemory%(256 * Value% + ByteNR%)
		NEXT ByteNR%
	CASE 0 TO 8191
		CPUMemory1(WritePlace!) = Value%
	CASE 8192 TO 20479
		CPUMemory2(WritePlace! - 8192) = Value%
	CASE 20480 TO 24575
		CPUMemory3(WritePlace! - 20480) = Value%
	CASE 24576 TO 32767
		CPUMemory4(WritePlace! - 24576) = Value%
	CASE 32768 TO 49151
		CPUMemory5(WritePlace! - 32768) = Value%
	CASE 49152 TO 65536
		CPUMemory6(WritePlace! - 49152) = Value%
END SELECT

END SUB

FUNCTION ZeroPage!
'Addressingmode Zeropage

		Register.PC = Register.PC + 1
		ZeroPage! = ReadMemory%(Register.PC)

END FUNCTION

FUNCTION ZeroPageX!
'Addressingmode Zeropage Indexed with Index X

		Register.PC = Register.PC + 1                                'Increase the program counter
		A = ReadMemory%(Register.PC)                                 'Get the byte
		ZeroPageXTemp! = A + Register.X                              'Add byte to index X
		IF (ZeroPageXTemp! AND 256) THEN ZeroPageXTemp! = ZeroPageXTemp! AND 255 'Then make sure that it is not above the 255, because then it wouldn't be a zero page anymore!
		ZeroPageX! = ZeroPageXTemp!

END FUNCTION

FUNCTION ZeroPageY!
'Addressingmode Zeropage Indexed with Index Y

		Register.PC = Register.PC + 1                                'Increase the program counter
		A = ReadMemory%(Register.PC)                                 'Get the byte
		ZeroPageTempY! = A + Register.Y                              'Add the contents of register Y to the value of the byte
		IF (ZeroPageTempY! AND 256) THEN ZeroPageTempY! = ZeroPageTempY! AND 255 'Then make sure that it is not above the 255, because then it wouldn't be a zero page anymore!
		ZeroPageY! = ZeroPageYTemp!                                  'And finally return the correct zeropage address

END FUNCTION

